using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Scene_1_main : MonoBehaviour 
{	
	
	static Texture2D HEIGHTMAP1; // Fixed 128x128 for now. Greyscale


	// -----------------------------------------------------------------------
	void Start () 
	// -----------------------------------------------------------------------
	{
		HEIGHTMAP1 = Resources.Load("HeightMap1") as Texture2D;
		
		for (int x=0;x<1;x++)
		for (int z=0;z<1;z++)
		{
			BaseMapFactory.CreateMapObject("TheMap_"+x.ToString()+"_"+z.ToString(),new Vector3(0f,0f,0f));
			
			GameObject go = GameObject.Find("TheMap_"+x.ToString()+"_"+z.ToString());
			go.transform.position = new Vector3(128.0f*Mathf.Sqrt(3.0f)*x,0.0f,128.0f*z*1.5f);
		}	
		
		StartCoroutine(ChangeTextures()); 
	}
	
	// -----------------------------------------------------------------------
	void Update () 
	// -----------------------------------------------------------------------
	{
		GameObject.Find("FpsText").guiText.text = Time.deltaTime.ToString();
	}
	
	// -----------------------------------------------------------------------
	IEnumerator ChangeTextures () 
	// -----------------------------------------------------------------------
	{
		while(true)
		{			
			for (int i=0;i<20;i++)
			{
				int x = Random.Range(0,127);
				int z = Random.Range(0,127);
				
				Color c = HEIGHTMAP1.GetPixel(x,z); 
				
					 if (c.r*255.0f < (  0.0f+1.0f)) { c.r = 64.0f/255.0f; c.g = 64.0f/255.0f; c.b = 64.0f/255.0f;}
				else if (c.r*255.0f < ( 64.0f+1.0f)) { c.r =128.0f/255.0f; c.g =128.0f/255.0f; c.b =128.0f/255.0f;}
				else if (c.r*255.0f < (128.0f+1.0f)) { c.r =192.0f/255.0f; c.g =192.0f/255.0f; c.b =192.0f/255.0f;}
				else { c.r =  0.0f/255.0f; c.g =  0.0f/255.0f; c.b =  0.0f/255.0f; }	
				
				HEIGHTMAP1.SetPixel(x,z,c); 
			}
			
			HEIGHTMAP1.Apply();
				
			GameObject.Find("TheMap_0_0").GetComponent<MeshRenderer>().material.SetTexture("_HeightTex", HEIGHTMAP1);
			yield return new WaitForSeconds(0.0f);
		}
	}
	
	
}
